diff --git a/CHANGES.txt b/CHANGES.txt
index ad7c950d8..838e96d2b 100644
--- a/CHANGES.txt
+++ b/CHANGES.txt
@@ -1,4 +1,4 @@
-CHANGES.txt - 2.2.0 - 2016-08-26
+CHANGES.txt - 2.2.0 - 2016-09-09
 --------------------------------
 
 CHANGES IN CUPS V2.2.0
@@ -8,6 +8,8 @@ CHANGES IN CUPS V2.2.0
 	- http*Connect did not work on Linux when cupsd was not running
 	  (Issue #4870)
 	- The --no-remote-any option of cupsctl had no effect (Issue #4866)
+	- http*Connect did not return early when all addresses failed
+	  (Issue #4870)
 
 
 CHANGES IN CUPS V2.2rc1
diff --git a/cups/http-addrlist.c b/cups/http-addrlist.c
index a760602bc..6e2ad8196 100644
--- a/cups/http-addrlist.c
+++ b/cups/http-addrlist.c
@@ -239,6 +239,9 @@ httpAddrConnect2(
       addrlist = addrlist->next;
     }
 
+    if (!addrlist && nfds == 0)
+      break;
+
    /*
     * See if we can connect to any of the addresses so far...
     */
